Package de.itu.bmu.viewer

# Class BMUController

java.lang.Object
de.itu.bmu.viewer.BMUController

public class BMUController extends Object
Diese Klasse liefert Methoden, mit denen BMU-Dokumente in eine anzeigbares HTML-Dokument transformiert werden können.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `BMUController.MyResolver`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `BEREICH_AE`
  Bereich Annahmeerklärung.
  `static final String`
  `BEREICH_AGS`
  Bereich AGS Bescheid.
  `static final String`
  `BEREICH_ALLE_SEITEN`
  Bereich alle Seiten.
  `static final String`
  `BEREICH_ALLE_SEITEN_RE`
  Bereich alle Seiten RE.
  `static final String`
  `BEREICH_ANHAENGE`
  Bereich unsignierte Anhänge.
  `static final String`
  `BEREICH_BB`
  Bereich Behördenbestätigung.
  `static final String`
  `BEREICH_BB_ANO`
  Bereich Behördenbestätigung / Anordnung.
  `static final String`
  `BEREICH_DA`
  Bereich Deklarationanalyse.
  `static final String`
  `BEREICH_DECKBLATT`
  Bereich Deckblatt.
  `static final String`
  `BEREICH_EB`
  Bereich Eingangsbestätigung.
  `static final String`
  `BEREICH_EGF`
  Bereich Ergänzendes Formblatt.
  `static final String`
  `BEREICH_ERZ_ENT_UEBERSICHT`
  `static final String`
  `BEREICH_ERZ_ENT_VOLLSTAENDIG`
  `static final String`
  `BEREICH_G11_FORMULAR`
  Bereich Formularansicht - Notifizierungsbogen und Begleitformular nach GUIDLINES 11
  `static final String`
  `BEREICH_G11_VOLLSTAENDIG`
  Bereich vollständige Ansicht - Notifizierungsbogen und Begleitformular nach GUIDLINES 11
  `static final String`
  `BEREICH_NF`
  Bereich Nachforderung.
  `static final String`
  `BEREICH_UEBERSICHT`
  Bereich Übersicht - Zusammenfassung und ggf. freie XML-Struktur enx für ein ENSN-Dokument.
  `static final String`
  `BEREICH_VE_SEITE_1`
  Bereich Verantwortliche Erklärung - Seite 1.
  `static final String`
  `BEREICH_VE_SEITE_2`
  Bereich Verantwortliche Erklärung - Seite 2.
  `static final String`
  `BEREICH_XTRA`
  Bereich Xtra - Freie XML-Struktur enx für ein ENSN-Dokument.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BMUController()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Map<String,de.itu.xmlsec.FileSignInfo>`
  `checkSignature(File f, de.consist.bmu.rule.BMUDokument bmuDok, int pos)`
  Diese Methode prüft eine oder mehrere Signaturen in einem BMU-Dokument.
  `static Map<String,de.itu.xmlsec.FileSignInfo>`
  `checkSignature(File f, Document doc, int pos)`
  Deprecated.
  `static void`
  `extractAttachment(de.consist.bmu.rule.BMUDokument bmuDok, String name, String docID, String outPath)`
  Diese Methode dient dazu, einen Dateianhang aus einem BMU-Dokument zu extrahieren.
  `static void`
  `extractAttachment(String inputPath, String name, String docID, String outPath)`
  Deprecated.
  `static void`
  `extractAttachment(Document doc, String name, String docID, String outPath)`
  Deprecated.
  `static List<de.itu.bmu.BMUAttachment>`
  `getAttachmentList(de.consist.bmu.rule.BMUDokument bmuDok)`
  Hilfsmethode, um eine Liste mit allen Attachments einer BMU-Nachricht zu bekommen
  `static List<de.itu.bmu.BMUAttachment>`
  `getAttachmentList(Document doc)`
  Deprecated.
  `static SortedMap<String,String>`
  `getLayerMap(de.consist.bmu.rule.BMUDokument bmuDok)`
  Hilfsmethode, um alle Layernamen eines Dokuments zu bekommen (die PreDokumente beim Abfallverbringungsdokument werden wie Layer behandelt)
  `static SortedMap<String,String>`
  `getLayerMap(Document doc)`
  Deprecated.
  `static de.itu.bmu.BMURegAuszug`
  `getRegAuszug(de.consist.bmu.rule.BMUDokument bmuDok)`
  `static de.itu.bmu.BMURegAuszug`
  `getRegAuszug(Document doc)`
  `static de.consist.bmu.rule.RuleSet`
  `getRuleSet()`
  `static void`
  `init()`
  Initialisierungsmethode, muss einmal aufgerufen werden
  `static void`
  `setRuleConfig(de.consist.bmu.rule.RuleFactory.RuleConfig ruleConfig)`
  `static File`
  `transform(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)`
  Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument.
  `static File`
  `transform(String filePath, Map<String,Object> params, String bereich)`
  Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument.
  `static File`
  `transform(Document doc, Map<String,Object> params, String bereich)`
  Deprecated.
  `static Document`
  `transformDoc(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)`
  Beschreibung siehe transformDoc(InputStream, Map, String)
  `static Document`
  `transformDoc(InputStream inStream, Map<String,Object> params, String bereich)`
  Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument.
  `static Document`
  `transformDoc(Document doc, Map<String,Object> params, String bereich)`
  Deprecated.
  `static File`
  `transformHTML(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)`
  Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument.
  `static File`
  `transformHTML(Document doc, Map<String,Object> params, String bereich)`
  Deprecated.
  `static de.consist.bmu.rule.RuleSetResult`
  `validate(de.consist.bmu.rule.BMUDokument bmuDok)`
  Diese Methode validiert ein übergebenes BMU-Dokument gegen das BMU-Schema
  `static boolean`
  `validate(Document doc, String fileName)`
  Deprecated.
  `static String`
  `xmlToString(Node node)`
  Hilfsmethode, um eine XML-Node in einen String umzuwandeln

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### BEREICH_BB

    public static final String BEREICH_BB
    Bereich Behördenbestätigung.
    See Also:
      - Constant Field Values

  - ### BEREICH_ANHAENGE

    public static final String BEREICH_ANHAENGE
    Bereich unsignierte Anhänge.
    See Also:
      - Constant Field Values

  - ### BEREICH_ALLE_SEITEN_RE

    public static final String BEREICH_ALLE_SEITEN_RE
    Bereich alle Seiten RE.
    See Also:
      - Constant Field Values

  - ### BEREICH_ALLE_SEITEN

    public static final String BEREICH_ALLE_SEITEN
    Bereich alle Seiten.
    See Also:
      - Constant Field Values

  - ### BEREICH_AGS

    public static final String BEREICH_AGS
    Bereich AGS Bescheid.
    See Also:
      - Constant Field Values

  - ### BEREICH_EGF

    public static final String BEREICH_EGF
    Bereich Ergänzendes Formblatt.
    See Also:
      - Constant Field Values

  - ### BEREICH_DA

    public static final String BEREICH_DA
    Bereich Deklarationanalyse.
    See Also:
      - Constant Field Values

  - ### BEREICH_NF

    public static final String BEREICH_NF
    Bereich Nachforderung.
    See Also:
      - Constant Field Values

  - ### BEREICH_BB_ANO

    public static final String BEREICH_BB_ANO
    Bereich Behördenbestätigung / Anordnung.
    See Also:
      - Constant Field Values

  - ### BEREICH_EB

    public static final String BEREICH_EB
    Bereich Eingangsbestätigung.
    See Also:
      - Constant Field Values

  - ### BEREICH_AE

    public static final String BEREICH_AE
    Bereich Annahmeerklärung.
    See Also:
      - Constant Field Values

  - ### BEREICH_VE_SEITE_2

    public static final String BEREICH_VE_SEITE_2
    Bereich Verantwortliche Erklärung - Seite 2.
    See Also:
      - Constant Field Values

  - ### BEREICH_VE_SEITE_1

    public static final String BEREICH_VE_SEITE_1
    Bereich Verantwortliche Erklärung - Seite 1.
    See Also:
      - Constant Field Values

  - ### BEREICH_DECKBLATT

    public static final String BEREICH_DECKBLATT
    Bereich Deckblatt.
    See Also:
      - Constant Field Values

  - ### BEREICH_UEBERSICHT

    public static final String BEREICH_UEBERSICHT
    Bereich Übersicht - Zusammenfassung und ggf. freie XML-Struktur enx für ein ENSN-Dokument.
    See Also:
      - Constant Field Values

  - ### BEREICH_XTRA

    public static final String BEREICH_XTRA
    Bereich Xtra - Freie XML-Struktur enx für ein ENSN-Dokument.
    See Also:
      - Constant Field Values

  - ### BEREICH_G11_FORMULAR

    public static final String BEREICH_G11_FORMULAR
    Bereich Formularansicht - Notifizierungsbogen und Begleitformular nach GUIDLINES 11
    See Also:
      - Constant Field Values

  - ### BEREICH_ERZ_ENT_UEBERSICHT

    public static final String BEREICH_ERZ_ENT_UEBERSICHT
    See Also:
      - Constant Field Values

  - ### BEREICH_ERZ_ENT_VOLLSTAENDIG

    public static final String BEREICH_ERZ_ENT_VOLLSTAENDIG
    See Also:
      - Constant Field Values

  - ### BEREICH_G11_VOLLSTAENDIG

    public static final String BEREICH_G11_VOLLSTAENDIG
    Bereich vollständige Ansicht - Notifizierungsbogen und Begleitformular nach GUIDLINES 11
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### BMUController

    public BMUController()

- ## Method Details

  - ### setRuleConfig

    public static void setRuleConfig(de.consist.bmu.rule.RuleFactory.RuleConfig ruleConfig)

  - ### init

    public static void init()
    Initialisierungsmethode, muss einmal aufgerufen werden

  - ### transformDoc

    public static Document transformDoc(InputStream inStream, Map<String,Object> params, String bereich)
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als DOM-Document zurückgegeben.
    Parameters:
      `inStream` - InputStream, der das zu transformierende Dokument enthält
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält. Mögliche Parameter:
      'positionsnummer' gibt den Layer an, der angezeigt wird, oberster Layer zuerst
      'layerName' der Name des Layers, dient zur Anzeige des Namens im HTML-Output
      'positionsnummerCharge' gibt die anzuzeigende Charge in einem Registerauszug an.
      'positionsnummerUNS' gibt den anzuzeigenden UNS in der BGSUNSCharge eines Registerauszugs an.
      `bereich` - Der Bereich in einem ENSN-Dokument, einem FR-Dokument oder einem Registerauszug der anzuzeigen ist.
      Mögliche Bereiche im EN/SN:
      'Übersicht'
      'Deckblatt' (Default, falls null übergeben wird)
      'Verantwortliche Erklärung - Seite 1'
      'Verantwortliche Erklärung - Seite 2'
      'Annahmeerklärung'
      'Eingangsbestätigung'
      'Behördenbestätigung / Anordnung'
      'Nachforderung'
      'Deklarationanalyse'
      'Ergänzendes Formblatt'
      'AGS Bescheid'
      'alle Seiten'
      'unsignierte Anhänge'
      Mögliche Bereiche im FR:
      'Deckblatt' (Default, falls null übergeben wird)
      'Behördenbestätigung'
      Mögliche Bereiche im Registerauszug:
      null oder '' für die Übersicht, ansonsten bezieht sich der Bereich auf den enthaltenen EN 'Deckblatt'
      'Verantwortliche Erklärung - Seite 1'
      'Verantwortliche Erklärung - Seite 2'
      'Annahmeerklärung'
    Returns:
      Das transformierte BMU-Dokument

  - ### transformDoc

    @Deprecated public static Document transformDoc(Document doc, Map<String,Object> params, String bereich)
    Deprecated.
    Beschreibung siehe transformDoc(InputStream, Map, String)
    Parameters:
      `doc` - Das Document
      `params` - Die Parameter
      `bereich` - Der Bereich
    Returns:
      Das transformierte BMU-Dokument

  - ### transformDoc

    public static Document transformDoc(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)
    Beschreibung siehe transformDoc(InputStream, Map, String)
    Parameters:
      `bmuDok` - Das BMUDokument
      `params` - Die Parameter
      `bereich` - Der Bereich
    Returns:
      Das transformierte BMU-Dokument

  - ### transform

    public static File transform(String filePath, Map<String,Object> params, String bereich)
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als File zurückgegeben.
    Parameters:
      `filePath` - Der Pfad zu der zu transformierenden Datei
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält.
      `bereich` - Der Bereich in einem ENSN-Dokument oder einem FR-Dokument, der anzuzeigen ist.
    Returns:
      Das transformierte BMU-Dokument als File

  - ### transform

    public static File transform(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als File zurückgegeben.
    Parameters:
      `bmuDok` - Das zu transformierende BMUDokument
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält.
      `bereich` - Der Bereich in einem ENSN-Dokument oder einem FR-Dokument, der anzuzeigen ist.
    Returns:
      Das transformierte BMU-Dokument als File

  - ### transform

    @Deprecated public static File transform(Document doc, Map<String,Object> params, String bereich)
    Deprecated.
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als File zurückgegeben.
    Parameters:
      `doc` - Das zu transformierende Document
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält.
      `bereich` - Der Bereich in einem ENSN-Dokument oder einem FR-Dokument, der anzuzeigen ist.
    Returns:
      Das transformierte BMU-Dokument als File

  - ### transformHTML

    public static File transformHTML(de.consist.bmu.rule.BMUDokument bmuDok, Map<String,Object> params, String bereich)
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als File zurückgegeben.
    Parameters:
      `bmuDok` - Das zu transformierende BMUDokument
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält.
      `bereich` - Der Bereich in einem ENSN-Dokument oder einem FR-Dokument, der anzuzeigen ist.
    Returns:
      Das transformierte BMU-Dokument als File

  - ### transformHTML

    @Deprecated public static File transformHTML(Document doc, Map<String,Object> params, String bereich)
    Deprecated.
    Diese Methode transformiert ein übergebenes BMU-Dokument in ein HTML-Dokument. Dieses wird als File zurückgegeben.
    Parameters:
      `doc` - Das zu transformierende Document
      `params` - Eine ParameterMap, die bei Layerdokumenten Informationen über das anzuzeigende Layer enthält.
      `bereich` - Der Bereich in einem ENSN-Dokument oder einem FR-Dokument, der anzuzeigen ist.
    Returns:
      Das transformierte BMU-Dokument als File

  - ### getLayerMap

    public static SortedMap<String,String> getLayerMap(de.consist.bmu.rule.BMUDokument bmuDok) throws Exception
    Hilfsmethode, um alle Layernamen eines Dokuments zu bekommen (die PreDokumente beim Abfallverbringungsdokument werden wie Layer behandelt)
    Parameters:
      `bmuDok` - das BMUDokument, aus dem die Layer ermittelt werden sollen
    Returns:
      eine Map mit den Layernamen als Keys
    Throws:
      `Exception` - Die Exception

  - ### getLayerMap

    @Deprecated public static SortedMap<String,String> getLayerMap(Document doc) throws Exception
    Deprecated.
    Hilfsmethode, um alle Layernamen eines Dokuments zu bekommen
    Parameters:
      `doc` - das Document, aus dem die Layer ermittelt werden sollen
    Returns:
      eine Map mit den Layernamen als Keys
    Throws:
      `Exception` - Die Exception

  - ### getAttachmentList

    public static List<de.itu.bmu.BMUAttachment> getAttachmentList(de.consist.bmu.rule.BMUDokument bmuDok) throws Exception
    Hilfsmethode, um eine Liste mit allen Attachments einer BMU-Nachricht zu bekommen
    Parameters:
      `bmuDok` - Das Document
    Returns:
      Liste von BMUAttachment Objekten
    Throws:
      `Exception` - Die Exception

  - ### getAttachmentList

    @Deprecated public static List<de.itu.bmu.BMUAttachment> getAttachmentList(Document doc) throws Exception
    Deprecated.
    Hilfsmethode, um eine Liste mit allen Attachments einer BMU-Nachricht zu bekommen
    Parameters:
      `doc` - Das Document
    Returns:
      Liste von BMUAttachment Objekten
    Throws:
      `Exception` - Die Exception

  - ### extractAttachment

    @Deprecated public static void extractAttachment(String inputPath, String name, String docID, String outPath)
    Deprecated.
    Diese Methode dient dazu, einen Dateianhang aus einem BMU-Dokument zu extrahieren.
    Parameters:
      `inputPath` - Der Pfad des BMU-Dokuments, aus dem der Anhang extrahiert werden soll
      `name` - Der Name des Dateianhangs
      `docID` - Die ID des Dateianhangs
      `outPath` - Der Pfad, in den das extrahierte Attachment gespeichert werden soll

  - ### extractAttachment

    public static void extractAttachment(de.consist.bmu.rule.BMUDokument bmuDok, String name, String docID, String outPath)
    Diese Methode dient dazu, einen Dateianhang aus einem BMU-Dokument zu extrahieren.
    Parameters:
      `bmuDok` - Das BMU-Dokument, aus dem der Anhang extrahiert werden soll
      `name` - Der Name des Dateianhangs
      `docID` - Die ID des Dateianhangs
      `outPath` - Der Pfad, in den das extrahierte Attachment gespeichert werden soll

  - ### extractAttachment

    @Deprecated public static void extractAttachment(Document doc, String name, String docID, String outPath)
    Deprecated.
    Diese Methode dient dazu, einen Dateianhang aus einem BMU-Dokument zu extrahieren.
    Parameters:
      `doc` - Das BMU-Dokument, aus dem der Anhang extrahiert werden soll
      `name` - Der Name des Dateianhangs
      `docID` - Die ID des Dateianhangs
      `outPath` - Der Pfad, in den das extrahierte Attachment gespeichert werden soll

  - ### validate

    public static de.consist.bmu.rule.RuleSetResult validate(de.consist.bmu.rule.BMUDokument bmuDok) throws Exception
    Diese Methode validiert ein übergebenes BMU-Dokument gegen das BMU-Schema
    Parameters:
      `bmuDok` - Das zu validierende BMU-Dokument.
    Returns:
      RuleSetResult
    Throws:
      `Exception` - Die Exception

  - ### validate

    @Deprecated public static boolean validate(Document doc, String fileName) throws Exception
    Deprecated.
    Diese Methode validiert ein übergebenes BMU-Dokument gegen das BMU-Schema
    Parameters:
      `doc` - Das zu validierende Dokument.
      `fileName` - optional, Name der zu prüfenden Datei
    Returns:
      true, wenn Dokument schemakonform, sonst false
    Throws:
      `Exception` - Die Exception

  - ### checkSignature

    public static Map<String,de.itu.xmlsec.FileSignInfo> checkSignature(File f, de.consist.bmu.rule.BMUDokument bmuDok, int pos) throws Exception
    Diese Methode prüft eine oder mehrere Signaturen in einem BMU-Dokument. Bei Abfallverbringungsdokumenten werden immer alle Signaturen geprüft.
    Parameters:
      `f` - Das zu prüfende BMU-Dokument als File
      `bmuDok` - Das zu prüfende BMU-Dokument
      `pos` - Die Position der zu prüfende Signatur, wird 0 übergeben, werden alle Signaturen geprüft
    Returns:
      Eine Map aus FileSignInfo-Objekten, die Informationen zum Ergebnis der Prüfungen enthält
    Throws:
      `Exception` - Die Exception

  - ### checkSignature

    @Deprecated public static Map<String,de.itu.xmlsec.FileSignInfo> checkSignature(File f, Document doc, int pos) throws Exception
    Deprecated.
    Diese Methode prüft eine oder mehrere Signaturen in einem BMU-Dokument.
    Parameters:
      `f` - Das zu prüfende BMU-Dokument als File
      `doc` - Das zu prüfende BMU-Dokument als Document
      `pos` - Die Position der zu prüfende Signatur, wird 0 übergeben, werden alle Signaturen geprüft
    Returns:
      Eine Map aus FileSignInfo-Objekten, die Informationen zum Ergebnis der Prüfungen enthält
    Throws:
      `Exception` - Die Exception

  - ### xmlToString

    public static String xmlToString(Node node)
    Hilfsmethode, um eine XML-Node in einen String umzuwandeln
    Parameters:
      `node` - Die umzuwandelnde Node
    Returns:
      Die umzuwandelnde Node als String

  - ### getRuleSet

    public static de.consist.bmu.rule.RuleSet getRuleSet()
    Returns:
      Das RuleSet

  - ### getRegAuszug

    public static de.itu.bmu.BMURegAuszug getRegAuszug(de.consist.bmu.rule.BMUDokument bmuDok) throws Exception
    Parameters:
      `bmuDok` - Das BMUDokument
    Returns:
      BMURegAuszug
    Throws:
      `Exception` - Die Exception

  - ### getRegAuszug

    public static de.itu.bmu.BMURegAuszug getRegAuszug(Document doc) throws Exception
    Parameters:
      `doc` - Das Document
    Returns:
      BMURegAuszug
    Throws:
      `Exception` - Die Exception